\class {field}
\security {1}
\name {HMML_figure}
\script {
	switch (arg[0]) {
	case "F":
		return get("height");
	break;
	case "D":
		if (tagPtr == 0) tagPtr = STG_tagPtr("FIGURE");
		if (tagPtr) {
			i = STG_attr(tagPtr, "BGColor");
			if (i) set("BGColor", i);
			i = STG_attr(tagPtr, "FGColor");
			if (i) set("FGColor", i);
			i = STG_attr(tagPtr, "BDColor");
			if (i) set("BDColor", i);
		}

		if (builtFig == 1) {
print("height=", get("height"), "\n");
			h = SGMLBuildDoc_span() + style[1];
print("h=", h, "\n");
			set("height", h);
			builtFig = 0;
			return h;
		} else if (src != 0) {
			builtFig = 1;

			h = SGMLBuildDoc_span();

			switch (bmType) {
			case "gif":
			case "image/gif":
				figTemplate = "HMML_giff";
			break;
			case "xbm":
			case "image/xbm":
				figTemplate = "HMML_xbmf";
			break;
			case "xpm":
			case "image/xpm":
				figTemplate = "HMML_xpmf";
			break;
			case "ps":
			case "application/postscript":
				figTemplate = "HMML_psf";
			break;
			}
			if (isBlank(figTemplate) == 1) {
				/* unknown type */
				return 0;
			} else {
				bitmapObj = send(figTemplate, "clone", self());
				w = width() - 10;
print("h3=", h, "\n");
				h += send(bitmapObj, "make", self(), w, h,
					 src, delayP, delayWidth, delayHeight,
					 ismap);
print("h4=", h, "\n");
				objectListAppend_children(bitmapObj);
				style = SGMLGetStyle("HMML", "FIGURE");
				return style[0] + h;
			}
		} else {
			if (isBlank(get("label")) == 1) return -1;

			builtFig = 1;
			h = SGMLBuildDoc_span();
print("h2=", h, "\n");

			switch (bmType) {
			case "gif":
			case "image/gif":
				figTemplate = "HMML_gif";
			break;
			case "xbm":
			case "image/xbm":
				figTemplate = "HMML_xbm";
			break;
			case "xpm":
			case "image/xpm":
				figTemplate = "HMML_xpm";
			break;
			case "ps":
			case "application/postscript":
				figTemplate = "HMML_ps";
			break;
			}

			if (isBlank(figTemplate) == 1) {
				/* unknown type */
				return 0;
			} else {
				bitmapObj = send(figTemplate, "clone", self());
				w = width() - 10;

				h += send(bitmapObj, "make", self(), w, h,
					 get("label"), ismap);

				objectListAppend_children(bitmapObj);
				style = SGMLGetStyle("HMML", "FIGURE");
				return style[0] + h + style[1];
			}
		}
	break;
	case 'R': /* resize */
		/* arg[1]	y
		 * arg[2]	width
		 * arg[3]	x (optional)
		 */
		style = SGMLGetStyle("HMML", "FIGURE");
		vspan = style[0];
		set("x", style[2]);
		set("y", arg[1] + vspan);
		set("width", arg[2] - x() - style[3]);

		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i++) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan += style[1];
		return vspan;
	break;
	case 'r':
		style = SGMLGetStyle("HMML", "SECTION");
		vspan = style[0];
		n = countChildren();
		if (n) {
			xx = width();
			for (i = 0; i < n; i++) {
				vspan = vspan 
					+ send(nthChild(i), 'R', vspan, xx);
			}
		}
		set("height", vspan);
		vspan += style[1];
		return vspan;
	break;
	case "data":
		SGMLBuildDoc_setBuff(-1);
		return compressSpaces(get("label"));
	break;
	case "AI":
		return;
	break;
	case "AA":
		switch (arg[1]) {
		case "TYPE":
			bmType = arg[2];
		break;
		case "ISMAP":
			ismap = 1;
		break;
		case "SRC":
			src = arg[2];
		break;
		case "MAXWIDTH":
			set("maxWidth", arg[2]);
		break;
		case "MINWIDTH":
			set("minWidth", arg[2]);
		break;
		case "WIDTH":
			delayWidth = arg[2];
		break;
		case "HEIGHT":
			delayHeight = arg[2];
		break;
		case "MAYDELAY":
			delayP = arg[2];
		break;
		}
		return;
	break;
	case "heightP":
		return get("height");
	break;
	case "widthP":
		return get("width");
	break;
	case "config":
		return;
	break;
	case "gotoAnchor":
		return 0;
	break;
	case "findTop":
		return send(parent(), "findTop");
	break;
	case "clone":
		return clone(arg[1]);
	break;
	}
	usual();
}
\width {100}
\height {30}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
