\class {vpane}
\name {mvw}
\children {mvw.doc}
\script {
/*for(i=0; i<arg[]; i++) print("WWW arg[",i,"]={", arg[i], "}\n");*/

	/* This is a GUI-less version of www.v, which the Motif frontend
	 * wraps around of.
	 *
	 * Author: 	Pei Y. Wei
	 */

	/* URL port configurtion. 0 == off.
	 */
	URLPort = 0;

	switch (arg[0]) {
	case "shownPositionV":
		/* message from Motif interface shell */
		return send("mvw.doc.view.pane", arg[0], arg[1]);
     	break;
	case "historyList_selectedItem":
		return send("mvwHistory", arg[0], arg[1]);
     	break;
	case "cloneApp":
		/* arg[1]	cookie -- is a unique token to be passed back
		 */
		new = clone(cookie);
		return sendToInterface("showAppClone", cookie, new);
	break;
	case "clonePage":
	case "saveAs":
		/* arg[1]	cookie
		 */
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "reload":
	case "showSource":
		return send(nthChild(0), arg[0]);
	break;
	case "historyQuery":
		/* arg[1]	cookie
		 */
		return mvwHistory("historyQuery", arg[1]);
	break;
	case "showPageClone_return":
		/* arg[1] must be the cookie */
		return sendToInterface("showPageClone", arg[1], arg[2]);
	break;
	case "show":
	case "post":
		if (arg[] == 2)
			stat = send("mvw.doc.view.pane", arg[0], arg[1]);
		else if (arg[] == 3)
			stat = send("mvw.doc.view.pane", arg[0], arg[1], 
							 arg[2]);
		else	stat = send("mvw.doc.view.pane", arg[0], arg[1], 
							 arg[2], arg[3]);
		if (stat) stat = send("mvw.doc.view.pane", "historyRecord");
		return stat;
	break;
	case "show_URL_in_selectionBuffer":
		return send("mvw.doc.view.pane", "show",
				trimEdge(getSelection()));
	break;
	case "showHistoryDoc":
		if (arg[] == 2) {
			stat = send("mvw.doc.view.pane", arg[0], arg[1]);
		} else {
			stat = send("mvw.doc.view.pane", arg[0], arg[1],
					arg[2]);
		}
		return stat;
	break;
	case "showHistory":
		/* arg[1]	cookie
		 * arg[2]	position in history list
		 */
		return mvwHistory("showByPosition", arg[1], arg[2]);
	break;
	case "addToHistory":
		send("mvwHistory", "add", arg[1], arg[2]);
		return;
	break;
	case "changeFonts":
		send("res.font", arg[1]);
		/* bug: only main viewer is told of the font change */
		send("mvw.doc.view.pane", "configSelf");
		return;
	break;
	case "group":
		mvw.doc.title.icon("group", arg[1]);
		return;
	break;
	case "destroyDoc":
		return mvw.doc.view.pane("destroyDoc");
	break;
	case "search":
		mvw.doc.view.pane("search", arg[1]);
		return;
	break;
	case "showButNoRecord":
		mvw.doc.view.pane("show", arg[1]);
		return;
	break;
	case "about_viola":
		environVar_VIOLA = environVar("VIOLA");
		if (isBlank(environVar_VIOLA)) {
			mvw.doc.view.pane("show", 
			"http://xcf.berkeley.edu/ht/projects/viola/docs/viola/about.html");
		} else {
			mvw.doc.view.pane("show", 
				  concat(environVar("VIOLA"), 
		       "/violaDocs/docs/viola/about_localVersion.html"),
				  "file:");
		}
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "linkTo_cern":
		mvw.doc.view.pane("show", 
			"http://info.cern.ch/hypertext/WWW/TheProject.html");
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "linkTo_gnn":
		mvw.doc.view.pane("show", 
			"http://nearnet.gnn.com");
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "linkTo_violaCentral":
		mvw.doc.view.pane("show", 
			"http://xcf.berkeley.edu/ht/projects/viola/violaCentral.html");
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "about_browser":
		environVar_VIOLA = environVar("VIOLA");
		if (isBlank(environVar_VIOLA)) {
			mvw.doc.view.pane("show", 
			"http://xcf.berkeley.edu/ht/projects/viola/docs/viola/help_motif.html");
/*"ftp://ora.com/pub/www/viola/docs/viola/help_motif.html");*/
		} else {
			mvw.doc.view.pane("show", 
				concat(environVar("VIOLA"), 
					"/violaDocs/docs/viola/help.html"),
/*				"/violaDocs/docs/viola/help_motif.html"),*/
				"file:");
		}
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "printDoc":
		/* arg[1]	printCmd
		 */
	break;
	case "saveDoc":
		/* arg[1]	file path
		 */
	break;
	case "saveSource":
	break;
	case "queryDocSecurity":
		/* for interface to get doc level security level */
	break;
	case "setSecurityClearence":
		/* coming from interace */
	break;
	case "querySecurityClearence":
		/* send to interface */
	break;
	case "home":
		mvw.doc.view.pane("showHistoryDoc", homeDoc);
		mvw.doc.view.pane("historyRecord");
		return;
	break;
	case "prev":
		wantIt = mvwHistory("prev");
		if (isBlank(wantIt) == 0) {
			mvw.doc.view.pane("showHistoryDoc", wantIt);
			sendToInterface("prev", cookie);
		}
		return;
	break;
	case "next":
		wantIt = mvwHistory("next");
		if (isBlank(wantIt) == 0) {
			mvw.doc.view.pane("showHistoryDoc", wantIt);
			sendToInterface("next", cookie);
		}
		return;
	break;
	case "back":
		wantIt = mvwHistory("back");
		if (isBlank(wantIt) == 0) {
			mvw.doc.view.pane("showHistoryDoc", wantIt);
			sendToInterface("back", cookie);
		}
		return;
	break;
	case "busy":
		sendToInterface("busyCursor", cookie);
		return cursorShape(arg[0]);
	break;
	case "idle":
		sendToInterface("idleCursor", cookie);
		return cursorShape(arg[0]);
	break;
	case "quit":
/*		res("decAppCount");*/
		quit();
	break;
	case "homeDocP":
		return homeDoc;
	break;
	case "init":
		usual();

		homeDoc = environVar("WWW_HOME");
		if (isBlank(homeDoc) == 1) {
		    homeDoc = accessible("file:/usr/local/lib/WWW/default.html");
		    if (isBlank(homeDoc) == 1)
			homeDoc = "http://info.cern.ch/hypertext/WWW/TheProject.html";
		}
/*		mvwHistory("add", "(home)", homeDoc);
*/
		if (URLPort > 0) {
			print("WARNING: port number ", URLPort,
			" is now being used to accept URL fetch directives.");
			if (send(mvwDocuPort("listen", URLPort))) {
				print("ERROR: Sorry, failed to open port ",
				URLPort, " for listening to URL fetches\n");
			}
		}

		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	case "outputSGML":
		send("www.doc.view.pane", "outputSGML");
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
\class {generic}
\name {www}
\script {
	/* message forwarding service */
	switch (arg[0]) {
	case "show":
	case "post":
		if (arg[] == 2) 
			return send("mvw", arg[0], arg[1]);
		else if (arg[] == 3) 
			return send("mvw", arg[0], arg[1], arg[2]);
		else
			return send("mvw", arg[0], arg[1], arg[2], arg[3]);
	break;
	case "home":
	case "prev":
	case "next":
	case "showHistoryDoc":
	case "destroyDoc":
		return send("mvw", arg[0], arg[1]);
	break;
	case "addToHistory":
		return send("mvwHistory", "add", arg[1], arg[2]);
	break;
	}
	usual();
}
\
\class {vpane}
\name {mvw.doc}
\parent {mvw}
\children {mvw.doc.url mvw.doc.title mvw.doc.view}
\script {
	switch (arg[0]) {
	case "shownPositionV":
		return send(nthChild(2), arg[0], arg[1]);
	break;
	case "addTool":
	case "addTool_sticky":
	case "removeTool":
	case "destroyTool":
		return send("mvwTools", arg[0], arg[1]);
	break;
	case "clear":
		return send("mvwTools", arg[0]);
	break;
	case "reload":
	case "showSource":
		return send(nthChild(2), arg[0]);
	break;
	case "saveAs":
		return send(nthChild(2), arg[0], arg[1]);
	break;
	case "clonePage":
		/* arg[1]	cookie
		 */
		send(nthChild(2), "clonePage");
		tearPageID = tearPageID + 1;
		new = clone(tearPageID);
		tweak(new, "set(\"parent\", \"\");");
		send(new, "torn", send(nthChild(2), "whichPageP"), arg[1]);
		send(parent(), "showPageClone_return", arg[1], new);
		return;
	break;
	case "tear":
		tearPageID = tearPageID + 1;
		new = clone(tearPageID);
		tweak(new, "set(\"parent\", \"\");");
		send(new, "torn", send(nthChild(2), "whichPageP"));
		send(new, "render");
		return;
	break;
	case "torn":
		set("label", 
			send(send(nthChild(2), "whichPageP"), "queryAddress"));
		objectListSend_children("torn", arg[1], arg[2]);
		return;
	break;
	case "init":
		usual();
		tearPageID = 0;
						/* should be app bgcolor */
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	case "whichPageP":
		return send(nthChild(2), "whichPageP");
	break;
	case "quit":
		set("visible", 0);
		/*XXX should destroy */
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\width {595}
\height {400}
\
\class {txtDisp}
\name {mvw.doc.url}
\parent {mvw.doc}
\script {
	switch (arg[0]) {
	case "show":
		set("content", arg[1]);
		render();
		return;
	break;
	case "torn":
		return;
	break;
	}
	usual();
}
\font {fixed}
\BGColor {LemonChiffon4}
\FGColor {black}
\BDColor {black}
\maxHeight {20}
\gapH {-1}
\
\class {hpane}
\name {mvwTools}
\children {mvw.doc.tools.dyna mvw.doc.tools.ops mvw.doc.tools.sys mvw.doc.tools.vicon}
\script {
/*for(i=0; i<arg[]; i++) print("WWW>DOC>TOOLS arg[",i,"]={", arg[i], "}\n");
*/
	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
	case "removeTool":
	case "destroyTool":
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "clear":
		return send(nthChild(0), arg[0]);
	break;
	case "init":
		usual();
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\BDColor {black}
\BGColor {grey45}
\maxHeight {33}
\gapH {-1}
\
\class {hpane}
\name {mvw.doc.tools.dyna}
\parent {mvwTools}
\script {
/*print("MVW>DOC>TOOLS>DYNA arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
		new = object(arg[1]);
		for (i = objectListCount_children(); i >= 0; i--) 
			if (nthChild(i) == new) return 1;
		objectListAppend("children", new);
		tweak(new, concat("set(\"parent\", \"", self(), "\");"));
		send(new, "visible", 1);
		config();
		return 1;
	break;
	case "removeTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		config();
		return 1;
	break;
	case "destroyTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		send(new, "freeSelf");
		config();
		return 1;
	break;
	case "clear":
		set("children", "");
		return;
	break;
	case "go_url":
		return send("mvw", "show", arg[1]);
	break;
	case "go_home":
	case "go_prev":
	case "go_next":
	case "go_back":
		return send("mvw", arg[0]);
	break;
	case "init":
		usual();
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\BDColor {grey45}
\BGColor {grey45}
\
\class {hpane}
\name {mvw.doc.tools.ops}
\parent {mvwTools}
\children {mvw.doc.tools.ops.reload mvw.doc.tools.ops.clone}
\paneConfig {eastToWest}
\script {
	switch (arg[0]) {
	case "init":
		usual();
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\maxWidth {66}
\gapH {3}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.ops.reload}
\parent {mvw.doc.tools.ops}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("mvw", "reload");
	break;
	case "enter":
		send("www.mesg.tf", "suggest", "Click to reload the document");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * reload [] = {
"32 32 6 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"+	c red",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooo...........oooooooooO. ",
".Xooooooo.XXXXXXXX.X.ooooooooO. ",
".Xoooo+++.X......X.XX.oooooooO. ",
".Xoooo+++.XXXXXXXX.XXX.ooooooO. ",
".Xoooo+...X......X.....ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+...X.........XX.ooooooO. ",
".Xoooo+++.XXXXXXXXXXXX.ooooooO. ",
".Xoooo+................ooooooO. ",
".Xoooo++++++++++++++oooooooooO. ",
".Xoooo+...........++oooooooooO. ",
".Xoooo++++++++++++++oooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoo...Oo...o.ooO.OoO.Oo..oooO. ",
".Xoo.oo.o.ooo.oo.o.o.O.o.o.ooO. ",
".Xoo...Oo..oo.oo.o.o.o.o.o.ooO. ",
".Xoo.o.oo.ooo.oo.o.o...o.o.ooO. ",
".Xoo.oo.o.ooo.oo.o.o.o.o.o.ooO. ",
".Xoo.oo.o...o..oO.Oo.o.o..oooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};
}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.ops.clone}
\parent {mvw.doc.tools.ops}
\script {
	switch (arg[0]) {
	case "buttonRelease":
/*		send("mvw", "clone");*/
		sendToInterface("clone");
	break;
	case "enter":
		send("www.mesg.tf", "suggest", "Click to clone the document");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * clone [] = {
"32 32 5 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".Xooo..........ooooooooooooooO. ",
".Xooo.XXXXXXX.X.oooooooooooooO. ",
".Xooo.X....XX.XX.ooooooooooooO. ",
".Xooo.XXXXXXX.XXX.oooooooooooO. ",
".Xooo.X.....X.....oooooooooooO. ",
".Xooo.XXXXXXXXXXX.oooooooooooO. ",
".Xooo.X......X.........ooooooO. ",
".Xooo.XXXXXXXX.XXXXXX.X.oooooO. ",
".Xooo.X......X.X...XX.XX.ooooO. ",
".Xooo.XXXXXXXX.XXXXXX.XXX.oooO. ",
".Xooo.X......X.X....X.....oooO. ",
".Xooo.XXXXXXXX.XXXXXXXXXX.oooO. ",
".Xooo.XXXXXXXX.X........X.oooO. ",
".Xooo..........XXXXXXXXXX.oooO. ",
".Xoooooooooooo.X........X.oooO. ",
".Xoooooooooooo.XXXXXXXXXX.oooO. ",
".Xoooooooooooo.XXXXXXXXXX.oooO. ",
".Xoooooooooooo............oooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooo..o.oo...o.Oo.o...ooooO. ",
".Xoooo.Ooo.oo.o.o..o.o.ooooooO. ",
".Xoooo.ooo.oo.o.o.o..o..oooooO. ",
".Xoooo.ooo.oo.o.o.oO.o.ooooooO. ",
".Xoooo.Ooo.oo.o.o.oo.o.ooooooO. ",
".Xooooo..o..o...o.oo.o...ooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};
}
\maxWidth {33}
\BDColor {grey45}
\BGColor {grey45}
\
\class {hpane}
\name {mvw.doc.tools.sys}
\parent {mvwTools}
\children {mvw.doc.tools.sys.prev mvw.doc.tools.sys.back mvw.doc.tools.sys.next mvw.doc.tools.sys.home}
\paneConfig {eastToWest}
\script {
/*print("MVW>DOC>TOOLS>sys arg[0]={", arg[0], "}\n");*/

	switch (arg[0]) {
	case "addTool":
	case "addTool_sticky":
		new = object(arg[1]);
		for (i = objectListCount_children(); i >= 0; i--) 
			if (nthChild(i) == new) return 1;
		objectListAppend("children", new);
		tweak(new, concat("set(\"parent\", \"", self(), "\");"));
		send(new, "visible", 1);
		config();
		return 1;
	break;
	case "removeTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		config();
		return 1;
	break;
	case "destroyTool":
		new = object(arg[1]);
		objectListDelete("children", new);
		send(new, "visible", 0);
		send(new, "freeSelf");
		config();
		return 1;
	break;
	case "init":
		usual();
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\maxWidth {133}
\gapH {3}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.sys.prev}
\parent {mvw.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("mvw", "prev");
	break;
	case "enter":
		send("www.mesg.tf", "suggest",
			"Click to visit the previous document.");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * prev [] = {
"32 32 6 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c grey75",
"O	c gray30",
"+	c gray50",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoooooooooooooooooo..oooooooO. ",
".Xoooooooooooooooo..++.ooooooO. ",
".Xoooooooooooooo..++++.ooooooO. ",
".Xoooooooooooo..++++++.ooooooO. ",
".Xoooooooooo..++++++++.ooooooO. ",
".Xoooooooo..++++++++++.ooooooO. ",
".Xooooooo.++++++++++++.ooooooO. ",
".Xooooo.++++++++++++++.ooooooO. ",
".Xoooooo..++++++++++++.ooooooO. ",
".Xoooooooo..++++++++++.ooooooO. ",
".Xoooooooooo..++++++++.ooooooO. ",
".Xoooooooooooo..++++++.ooooooO. ",
".Xoooooooooooooo..++++.ooooooO. ",
".Xoooooooooooooooo..++.ooooooO. ",
".Xoooooooooooooooooo..oooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoooo...+o...+o...o.ooo.ooooO. ",
".Xoooo.oo.o.oo.o.ooo.ooo.ooooO. ",
".Xoooo.oo.o...+o..oo.+o+.ooooO. ",
".Xoooo...+o.o.oo.oooo.o.oooooO. ",
".Xoooo.oooo.oo.o.oooo.+.oooooO. ",
".Xoooo.oooo.oo.o...ooo.ooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};
}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.sys.back}
\parent {mvw.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("mvw", "back");
	break;
	case "enter":
		send("www.mesg.tf", "suggest", 
			"Click to go roll back the history list (destructive back up).");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * back [] = {
"32 32 7 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c gray",
"O	c gray30",
"+	c gray50",
"@	c grey75",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooooooooooooo.oooooooooooooO. ",
".Xoooooooooooo.+.ooooooooooooO. ",
".Xoooooooooooo.+.ooooooooooooO. ",
".Xooooooooooo.+++.oooooooooooO. ",
".Xooooooooooo.+++.oooooooooooO. ",
".Xoooooooooo.+++++.ooooooooooO. ",
".Xoooooooooo.+++++.ooooooooooO. ",
".Xooooooooo.+++++++.oooooooooO. ",
".Xooooooooo.+++++++.oooooooooO. ",
".Xoooooooo.+++++++++.ooooooooO. ",
".Xoooooooo.+++++++++.ooooooooO. ",
".Xooooooo.+++++++++++.oooooooO. ",
".Xooooooo.+++++++++++.oooooooO. ",
".Xoooooo.+++++++++++++.ooooooO. ",
".Xoooooo.+++++++++++++.ooooooO. ",
".Xooooooo.............oooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoooo...+oo+.+oo+..o.oo.ooooO. ",
".Xoooo.oo.oo.o.oo.ooo.o.oooooO. ",
".Xoooo...ooo.o.oo.ooo..ooooooO. ",
".Xoooo.oo.o+...+o.ooo..ooooooO. ",
".Xoooo.oo.o.+o+.o.ooo.@.oooooO. ",
".Xoooo...+o.ooo.o+..o.oo.ooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};
}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.sys.next}
\parent {mvw.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("mvw", "next");
	break;
	case "enter":
		send("www.mesg.tf", "suggest",
			"Click to visit the next document.");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * next [] = {
"32 32 6 1",
" 	s None	c None",
".	c black",
"X	c white",
"o	c grey75",
"O	c gray30",
"+	c gray50",
"............................... ",
".XXXXXXXXXXXXXXXXXXXXXXXXXXXXX. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xoooooooo..oooooooooooooooooO. ",
".Xooooooo.++..oooooooooooooooO. ",
".Xooooooo.++++..oooooooooooooO. ",
".Xooooooo.++++++..oooooooooooO. ",
".Xooooooo.++++++++..oooooooooO. ",
".Xooooooo.++++++++++..oooooooO. ",
".Xooooooo.++++++++++++..oooooO. ",
".Xooooooo.++++++++++++++.ooooO. ",
".Xooooooo.++++++++++++..oooooO. ",
".Xooooooo.++++++++++..oooooooO. ",
".Xooooooo.++++++++..oooooooooO. ",
".Xooooooo.++++++..oooooooooooO. ",
".Xooooooo.++++..oooooooooooooO. ",
".Xooooooo.++..oooooooooooooooO. ",
".Xoooooooo..oooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XoooooooooooooooooooooooooooO. ",
".Xooo.+oo.o...o.ooo.o.....oooO. ",
".Xooo..+o.o.ooo+.o.+ooo.oooooO. ",
".Xooo.o.+.o..+oo+.+oooo.oooooO. ",
".Xooo.oo..o.oooo+.+oooo.oooooO. ",
".Xooo.ooo.o.ooo+.o.+ooo.oooooO. ",
".Xooo.ooo.o...o.ooo.ooo.oooooO. ",
".XoooooooooooooooooooooooooooO. ",
".XOOOOOOOOOOOOOOOOOOOOOOOOOOOO. ",
"............................... ",
"                                "};
}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\
\class {XPMButton}
\name {mvw.doc.tools.sys.home}
\parent {mvw.doc.tools.sys}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		send("mvw","home");
	break;
	case "enter":
		send("www.mesg.tf", "suggest", 
			"Click the house icon to visit home page.");
		return;
	break;
	case "leave":
		send("www.mesg.tf", "clear");
		return;
	break;
	}
	usual();
}
\label {/* XPM */
static char * home [] = {
"32 32 9 1",
" 	c black",
".	c white",
"X	c grey75",
"o	c gray30",
"O	c red",
"+	c #E0E0D0D0B0B0",
"@	c lightyellow",
"#	c gray",
"$	c gray50",
"                                ",
" .............................  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXo  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXo  ",
" .XXXXXXXXXX       XXXXXXXXXXo  ",
" .XXXXXXXXX OOOOOOO XXXXXXXXXo  ",
" .XXXXXXXX O+@OOOOOO XXXXXXXXo  ",
" .XXXXXXXX O+@@OOOOOO XXXXXXXo  ",
" .XXXXXXX O+@@@OOOOOOO XXXXXXo  ",
" .XXXXXX O+@@@@@OOOOOOO XXXXXo  ",
" .XXXXX O+@@@@@@@OOOOOOO XXXXo  ",
" .XXXXX O+@@@@@@@@OOOOOOO XXXo  ",
" .XXXX O+@@@@@@@@@OOOOOOOO XXo  ",
" .XXX O+@@@#####@@@OOOO++ XXXo  ",
" .XXXX  @@@#   #@@@@+++++ XXXo  ",
" .XXXXX @@@#   #@@@@+++++ XXXo  ",
" .XXXXX @@@#   #@@@@+++++ XXXo  ",
" .XXXXX @@@#   #@@@@+++++ XXXo  ",
" .XXXXX @@@#   #@@@@++++  XXXo  ",
" .XXXXX @@@#   #@@@@++  XXXXXo  ",
" .XXXXXX             XXXXXXXXo  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXo  ",
" .XXXX XX X$  $X XXX X   XXXXo  ",
" .XXXX XX X XX X  X  X XXXXXXo  ",
" .XXXX    X XX X $ $ X  XXXXXo  ",
" .XXXX XX X XX X X X X XXXXXXo  ",
" .XXXX XX X XX X XXX X XXXXXXo  ",
" .XXXX XX X$  $X XXX X   XXXXo  ",
" .XXXXXXXXXXXXXXXXXXXXXXXXXXXo  ",
" .oooooooooooooooooooooooooooo  ",
"                                ",
"                                "};
}
\maxWidth {31}
\BDColor {grey45}
\BGColor {grey45}
\gapH {-1}
\
\class {XBM}
\name {mvw.doc.tools.vicon}
\parent {mvw.doc.tools}
\script {
	switch (arg[0]) {
	case "init":
		usual();
		color = getResource("Viola*background");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\label {#define violaIcon_width 32
#define violaIcon_height 32
static char violaIcon_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00,
   0x38, 0x0c, 0x1e, 0x00, 0x0c, 0x18, 0x73, 0x00, 0x06, 0xf0, 0xc1, 0x00,
   0x02, 0x60, 0xc0, 0x00, 0x03, 0x00, 0x80, 0x01, 0x01, 0x00, 0x80, 0x51,
   0x01, 0x00, 0x80, 0x51, 0x01, 0x20, 0xe9, 0xff, 0xc1, 0x03, 0x00, 0x50,
   0xc1, 0x03, 0x00, 0x50, 0x81, 0x03, 0x01, 0x50, 0x82, 0x03, 0x01, 0x00,
   0x06, 0x07, 0x01, 0x00, 0x0c, 0x87, 0x00, 0x01, 0x7c, 0x86, 0x02, 0x1d,
   0x78, 0x8e, 0x00, 0x21, 0x70, 0x4c, 0x32, 0x21, 0x00, 0x48, 0x4a, 0x39,
   0x00, 0x58, 0x4a, 0x25, 0x00, 0x70, 0x4a, 0x25, 0x00, 0x30, 0x32, 0x79,
   0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};}
\maxWidth {32}
\BDColor {grey45}
\BGColor {grey45}
\FGColor {black}
\gapH {3}
\
\class {txtDisp}
\name {mvw.doc.title}
\script {
	switch (arg[0]) {
	case "show":
		if (isBlank(arg[1])) {
/*			set("content", "<No Title>");*/
			set("content", "");
		} else {
			if (textWidth(5/*bold_large*/, arg[1])+10 < width()) {
				/*set("font", "bold_largest");*/
				set("content", concat("\\f(5)", arg[1]));
			} else {
				/* this is so broken
				set("font", "bold");
				*/
				set("content", concat("\\f(4)", arg[1]));
			}
		}
		render();
		return;
	break;
	case "torn":
		return;
	break;
	case "init":
		usual();
		color = getResource("Viola.background_toolbar");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\content {this is where the page title goes}
\BDColor {black}
\BGColor {LemonChiffon3}
\FGColor {black}
\maxHeight {38}
\gapV {1}
\gapH {1}
\font {bold_large}
\format {1}
\
\class {hpane}
\name {mvw.doc.view}
\parent {mvw.doc}
\gapH {0}
\children {mvw.doc.view.pane}
\script {
/*
print("mvw.doc.view: ");
for (i=0; i<arg[]; i++) print("arg", i, " = ", arg[i], "\n");
print("\n");
*/
	switch (arg[0]) {
	case "shownPositionV":
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "reload":
	case "showSource":
		return send(nthChild(0), arg[0]);
	break;
	case "saveAs":
		return send(nthChild(0), arg[0], arg[1]);
	break;
	case "tear":
	case "quit":
		send(get("parent"), arg[0]);
		return;
	break;
	case "clonePage":
		pagePane = get("content");
		return;
	break;
	case "torn":
		objectListSend_children("torn", arg[1], arg[2]);
		pagePane = get("content");
		return;
	break;
	case "whichPageP":
		return send(pagePane, "whichPageP");
	break;
	case "key_up":
	case "key_down":
		return send(nthChild(0), arg[0]);
	break;
	case "addTool":
	case "addTool_sticky":
	case "removeTool":
	case "destroyTool":
		return send(parent(), arg[0], arg[1]);
	break;
	case "sliderConfig":
		send(self(), "configSelf");
		pagePane = nthChild(0);
		set("content", pagePane);
		return;
	break;
	case "init":
		usual();
		pagePane = nthChild(0); /* default scrolbar at right side */
		set("content", pagePane);
		color = getResource("Viola.background_doc");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	}
	usual();
}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
\class {field}
\name {mvw.doc.view.pane}
\parent {mvw.doc.view}
\script {
	switch (arg[0]) {
	case "shownPositionV":
		sliderPos = arg[1];
		return send(pageObj, arg[0], sliderPos);
	break;
	case "key_up":
		return send(pageObj, "scrollPageDown");
	break;
	case "key_down":
		return send(pageObj, "scrollPageUp");
	break;
	case "procratinate_show":
		if (hasConfiged) {
			stat = send("mvw.doc.view.pane", "show", arg[1]);
			send("mvw.doc.view.pane", "historyRecord");
		} else {
/* wait after the window has opened and configured to the correct size */
			after(1000, self(), "procratinate_show", arg[1]);
		}
		return;
	break;
	case "show":
	case "post":
	case "showHistoryDoc":
		sendToInterface("busyCursor", cookie);
		cursorShape("busy");
		if (arg[0] == "post") {
			doPost = 1;
			postData = arg[3];
		} else { 
			doPost = 0;
			postData = 0;
		}
		if (torn == 1) {
			if (arg[] == 2) 
				stat = send("mvw.doc.view.pane", arg[0], arg[1]);
			else if (arg[] == 3) 
				stat = send("mvw.doc.view.pane", arg[0], arg[1], arg[2]);
			else	stat = send("mvw.doc.view.pane", arg[0], arg[1], arg[2], arg[3]);
			sendToInterface("idleCursor", cookie);
			cursorShape("idle");
			return stat;
		}
		if (nthChar(arg[1], 0) == '#') {
			pageYPos = send(pageObj, "gotoAnchor", 
					nthChar(arg[1], 1, 999));

			pageHeight = send(pageObj, "vspan");
			heightDiff = pageHeight - get("height");
			heightRatio =  float(heightDiff) / -100.0;

			if (heightDiff > 0) {
				sliderSize = float(get("height")) / float(pageHeight) * 100;
				sliderPos = float(pageYPos) / float(heightDiff) * 100;
				if (sliderPos > 100) sliderPos = 100;
			} else {
				sliderSize = 100;
				sliderPos = 0;
			}
			send(pageObj, "shownPositionV", sliderPos);
		} else {
			if (arg[] == 2)
			  normURL = send("normalizeURL", "normalizeURL", arg[1]);
			else 
			  normURL = send("normalizeURL", "normalizeURL", arg[1], arg[2]);

			if (hasConfiged == 0) {
				docToRenderAfterConfigure = normURL;
				sendToInterface("idleCursor", cookie);
				cursorShape("idle");
				return 0;
			}
			docName = normURL;
			docURL = normURL;

			if (findPattern(arg[1], "telnet:") != -1) {
				stat = send("mvw.delegationHandler", 
						"doTelnet", normURL);
				sendToInterface("idleCursor", cookie);
				cursorShape("idle");
				return stat;
			} else if (findPattern(arg[1], "mailto:") != -1) {
				stat = send("mvw.delegationHandler", 
						"doMailTo", normURL);
				sendToInterface("idleCursor", cookie);
				cursorShape("idle");
				return stat;
			}

			anchor = parseHTTPAddress("anchor", normURL);
			if (exist(docName) == 1) {
				set("children", docName);
				if (anchor != "")  {
					pageYPos = send(docName, 
						"gotoAnchor", anchor) * -1;
					send(docName, "y", pageYPos);
				} else {
					pageYPos = send(docName, "yP");
				}
				send(docName, "display", get("width"), get("height"));
				send(docName, "raise");
			} else {
				/* a rough guess at the document type */
				handler = wwwFormatDetect("type", docURL);
				docObj = send("wwwHandlerDispatch", 
					"dispatch", handler, doPost, docURL, 
					docName, self(), get("width"), get("height"),
					anchor, 1, postData);
				cursorShape("idle");
				if (docObj == 0) {
					sendToInterface("warningDialog",
						cookie, concat("Failed to access\n", docURL));
					sendToInterface("idleCursor", cookie);
					cursorShape("idle");
					return 0;
				} else if (docObj == 1) {
					/* It's OK.. no doc object generated
					 * but wasn't an error (ie: to be 
					 * rendered by external viewer)
					 */
					cursorShape("idle");
					return 0;
				}
				if (insertObjCount > 0) {
					for (i = 0; i < insertObjCount; i++)
						send(insertObj[i], "insert");
					insertObjCount = 0;
					send(self(),'R',get("y"),get("width"));
				}
				send(docName, "display", get("width"), get("height"));
				send(docName, "show");
				pageYPos = send(docName, "yP");
			}
			if (pageObj) send(pageObj, "VW_event", "VIEW_OFF");
			pageObj = object(docName);
			send(pageObj, "VW_event", "VIEW_ON");
			pageHeight = send(pageObj, "vspan");
			send(self(), "configShare");
		}
		if (docObj != 0) {
			title = send(pageObj, "queryTitle");
			if (isBlank(title)) title = pageObj;

			mvw.doc.title("show", title);
			mvw.doc.url("show", docURL);

			if (arg[0] == "show") {
			  if (isBlank(title))
				sendToInterface("newDocument", cookie, docURL);
			  else
				sendToInterface("newDocument", cookie, docURL, title);
			} else { /* arg[0] == "showHistoryDoc" */
			    if (isBlank(title))
			    	sendToInterface("historyDocument", cookie, docURL);
			    else
			    	sendToInterface("historyDocument", cookie, docURL, title);
			}
			sendToInterface("sliderConfig", cookie, sliderPos, sliderSize);
		
			indexP = send(pageObj, "queryIsIndex");
			if (indexP) sendToInterface("searchOn", cookie);
			else sendToInterface("searchOff", cookie);
		}
		sendToInterface("idleCursor", cookie);
		cursorShape("idle");
		return docName;
	break;
	case "toDoInsert":
		insertObj[insertObjCount] = arg[1];
		insertObjCount++;
		return;
	break;
	case "show_request_by_child":
	case "post_request_by_child":
		if (arg[0] == "post_request_by_child") realMesg = "post";
		else realMesg = "show";

		if (torn == 1) destObj = self;
		else destObj = object("mvw");

		if (arg[] == 3) stat = send(destObj, realMesg, arg[1], arg[2]);
		else stat = send(destObj, realMesg, arg[1], arg[2], arg[3]);
		return stat;
	break;
	case "hintOn":
	case "hintOff":
		return;
	break;
	case "setChildren":
		set("children", arg[1]);
		return;
	break;
	case "configShare":
		heightDiff = pageHeight - get("height");
		heightRatio =  float(heightDiff) / -100.0;
		/* not working right... should maintain proportional offset */
		if (heightDiff > 0) {
			sliderSize = float(height()) / float(pageHeight) * 100;
			sliderPos = float(pageYPos) / float(heightDiff) * -100;
		} else {
			sliderSize = 100;
			sliderPos = 0;
		}
		return;
	break;
	case "configSlider":
		/* arg[1]	pageYPos
		 * arg[2]	pageHeight
		 */
		pageYPos = arg[1];
		pageHeight = arg[2];
		if (pageYPos + pageHeight < get("height")) {
			pageYPos = get("height") - pageHeight;
			if (pageYPos > 0) pageYPos = 0;
			send(pageObj, "y", pageYPos);
		}
		send(self(), "configShare");
		sendToInterface("sliderConfig", cookie, sliderPos, sliderSize);
		return;
	break;
	case "config":
		usual();
		send(pageObj, "resize", get("width"), get("height"));
		pageYPos = send(pageObj, "yP");
		pageHeight = send(pageObj, "vspan");
		if (pageYPos + pageHeight < get("height")) {
			pageYPos = get("height") - pageHeight;
			if (pageYPos > 0) pageYPos = 0;
			send(pageObj, "y", pageYPos);
		}
		/*XXX a bit tweetchy */
		send(self(), "configShare");
		sendToInterface("sliderConfig", cookie, sliderPos, sliderSize);
		if (hasConfiged == 0) {
			hasConfiged = 1;
			if (docToRenderAfterConfigure) {
				stat = send(self(), "show", 
					docToRenderAfterConfigure);
				if (stat) send(self(), "historyRecord");
			}
		}
		return;
	break;
	case "update":
		pageObj = nthChild(0);
		pageHeight = arg[1];
		heightDiff = pageHeight - get("height");
		heightRatio =  float(heightDiff) / -100.0;
		if (heightDiff > 0) h = arg[1];
		else h = get("height");
		return h;
	break;
	case "destroyDoc":
	case "destroyDoc_qualified":
		send(pageObj, "freeSelf");
		pageObj = 0;
		return;
	break;
	case "addTool":
	case "addTool_sticky":
	case "removeTool":
	case "destroyTool":
		return send(parent(), arg[0], arg[1]);
	break;
	case "search":
		return send(pageObj, "search", arg[1]);
	break;
	case "outputSGML":
		return send(pageObj, "outputSGML");
	break;
	case "mailToAuthor":
		contactURL = send(pageObj, "queryAuthor");
		if (contactURL) {
			res.dialogWithButtons("show", 
			 concat("The declared author contact is:\n", 
				contactURL),
			 "Dismiss", "");
		} else {
			res.dialogWithButtons("show", 
			 "Sorry, no author contact declared in the document.",
			 "Dismiss", "");
		}
		return;
	break;
	case "reload":
		/* is a problem if reloading 'URL#anchor' ? */
		sendToInterface("sliderConfig", cookie, 0, sliderSize);
		return send(pageObj, "reload");
	break;
	case "whichPageP":
		return nthChild(0);
	break;
	case "heightP":
		return get("height");
	break;
	case "expose":
		if (todo) {
			homeDoc = mvw("homeDocP");
			mvw("show", homeDoc);
			todo = 0;
		}
		return;
	break;
	case "reportNextID":
	case 'R':
		return;
	break;
	case "historyRecord":
		send(pageObj, "historyRecord");
		return;
	break;
	case "showSource":
		/* return temporary file */
		sendToInterface("showSourceFile", cookie, 
				HTTPGet(docURL), "editable"); 
		return;
	break;
	case "saveAs":
		/* return temporary file */
		sendToInterface("saveAs", cookie, HTTPGet(docURL), arg[1]);
		return;
	break;
	case "init":
		usual();
		todo = 0;
		color = getResource("Viola.background_doc");
		if (color) {
			set("BGColor", color);
			set("BDColor", color);
		}
		return;
	break;
	case "torn":
		cookie = arg[2];
		torn = 1;
		send(nthChild(0), "torn", arg[1]);
		pageObj = nthChild(0);
		/* make self reset variables */
		send(self(), "update", send(pageObj, "vspan"));
		return;
	break;
	}
	usual();
}
\width {595}
\height {400}
\BGColor {LemonChiffon1}
\BDColor {LemonChiffon1}
\
\name {mvw.delegationHandler}
\class {generic}
\script {
	switch (arg[0]) {
	case "doTelnet":
		/* arg[1]	normalized URL
		 */
		cmd = send("WWWTelnetHandler", "connect", arg[1]);
		system(cmd);
		return 1;
	break;
	case "doMailTo":
		/* arg[1]	normalized URL
		 */
		subject = concat("WWW mail from: ", arg[1]);
		tt = arg[1];
		i = findPattern(tt, "/");
		if (i == -1) {
			address = nthChar(tt, 7, 999);
			content = concat("This mail was generated by URL:\n",
					 tt, "\n");
		} else {
			address = nthChar(tt, 7, i-1);
			content = concat(nthChar(tt, i+1, 999), "\n");
		}
		tmpFile = makeTempFile();
		saveFile(tmpFile, content);

		cmd = concat("mail -s \"", subject,
				 "\" ", address, " < ", tmpFile);
		system(cmd);
		system(concat("rm ", tmpFile));
		return 1;
	break;
	}
	usual();
}
\
\class {generic}
\name {www.mesg.tf}
\script {
	switch (arg[0]) {
	case "clear":
		if (isCleared == 0) {
			test1();
			isCleared = 1;
		}
		return;
	break;
	case "show":
	case "flash":
	case "suggest":
		isCleared = 0;
		return test1(arg[1]);
	break;
	case "alert":
	case "warn":
	case "error":
		isCleared = 0;
		sendToInterface("modalErrorDialog",
				0, /* may be on top of the wrong shell--
				    * now always go on main shell */
				arg[1]);
		return;
	break;
	}
	usual();
}
\
