\name {wwwHistory}
\class {vpane}
\parent {}
\script	{
	print("wwwHistory: ");
	for (i = 0; i < arg[]; i++) print(arg[i], ", ");
	print("\n");

	switch (arg[0]) {
	case "add":
		wwwHistory.list.tf("add", arg[1], arg[2]);
		return;
	break;
	case "back":
	case "prev":
	case "next":
	case "peek_prev":
	case "peek_next":
	case "toggle":
	case "peek_back":
		wwwHistory.list.tf(arg[0]);
		return;
	break;
	case "historyQuery":
		wwwHistory.list.tf(arg[0], arg[1]);
		return;
	break;
	case "visible":
		set("visible", arg[1]);
		return;
	break;
	case "dismiss":
		set("visible", 0);
		return;
	break;
	case "render":
		set("visible", 1);
		raise();
		return;
	break;
	case "raise":
		raise();
		return;
	break;
	}
	usual();
}
\width {500}
\height {150}
\children {wwwHistory.top wwwHistory.list}
\
\name {wwwHistory.top}
\class {hpane}
\parent	{wwwHistory}
\children {wwwHistory.top.prev wwwHistory.top.back wwwHistory.top.next wwwHistory.top.title wwwHistory.top.dismiss}
\maxHeight {20}
\
\name {wwwHistory.top.prev}
\class {txtButton}
\parent	{wwwHistory.top}
\label {<Prev}
\font {normal}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		docAddr = wwwHistory.list.tf("prev");
		if (isBlank(docAddr) != 1) www("showButNoRecord", docAddr);
	break;
	}
	usual();
}
\maxWidth {70}
\BDColor {white}
\BGColor {grey45}
\
\name {wwwHistory.top.back}
\class {txtButton}
\parent	{wwwHistory.top}
\label {^Back}
\font {normal}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		docAddr = wwwHistory.list.tf("back");
		if (isBlank(docAddr) != 1) www("showButNoRecord", docAddr);
	break;
	}
	usual();
}
\maxWidth {70}
\BDColor {white}
\BGColor {grey45}
\
\name {wwwHistory.top.next}
\class {txtButton}
\parent	{wwwHistory.top}
\label {Next>}
\font {normal}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		docAddr = wwwHistory.list.tf("next");
		if (isBlank(docAddr) != 1) www("showButNoRecord", docAddr);
	break;
	}
	usual();
}
\maxWidth {70}
\BDColor {white}
\BGColor {grey45}
\
\name {wwwHistory.top.title}
\class {txtLabel}
\parent	{wwwHistory.top}
\label {World-Wide Web Travels}
\font {bold}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		wwwHistory.list.tf("dump");
	break;
	}
	usual();
}
\FGColor {black}
\BGColor {grey45}
\
\name {wwwHistory.top.dismiss}
\class {txtButton}
\parent	{wwwHistory.top}
\label {Dismiss}
\font {normal}
\script {
	switch (arg[0]) {
	case "buttonRelease":
		wwwHistory("dismiss");
		return;
	break;
	}
	usual();
}
\maxWidth {70}
\BDColor {white}
\BGColor {grey45}
\
\name {wwwHistory.list}
\class {hpane}
\parent {wwwHistory}
\children {wwwHistory.list.tf wwwHistory.list.sb}
\
\name {wwwHistory.list.sb}
\class {slider}
\parent {wwwHistory.list}
\shownNotify {wwwHistory.list.tf}
\BDColor {white}
\BGColor {grey45}
\FGColor {grey75}
\maxWidth {20}
\
\name {wwwHistory.list.tf}
\parent {wwwHistory.list}
\class {txtDisp}
\script	{
	switch (arg[0]) {
	case "buttonRelease":
		if (isBlank(currentLine()) == 1) {
			bell();
		} else {
			deHighLight(index);
			previousDocIndx = index;
			/*index = lineRowOffset() + cursorRow();*/
			index = cursorRow();
			highLight(index);
			if (get("window")) render();
		}
		www("showButNoRecord", docAddr[index]);
	break;
	case "prev":
		if (index > 0) {
			deHighLight(index);
			previousDocIndx = index;
			index--;
			highLight(index);
			if (get("window")) render();
			return docAddr[index];
		} else {
			bell();
			return "";
		}
	break;
	case "peek_prev":
		if (index > 0) return docTitle[index - 1];
		else return "none";
	break;
	case "next":
		if (index < count - 1) {
			deHighLight(index);
			previousDocIndx = index;
			index++;
			highLight(index);
			if (get("window")) render();
			return docAddr[index];
		} else {
			bell();
			return "";
		}
	break;
	case "peek_next":
		if (index + 1 < count) return docTitle[index + 1];
		else return "none";
	break;
	case "toggle":
		if (previousDocIndx == -1) {
			return "";
		} else {
			deHighLight(index);
			temp = index;
			index = previousDocIndx;
			previousDocIndx = temp;
			highLight(index);
			if (get("window")) render();
			return docAddr[index];
		}
	break;
	case "peek_back":
		if (index != 0) return docTitle[index - 1];
		else return "none";
	break;
	case "add":
		deHighLight(index);
		previousDocIndx = index;
		index = count;

print("HISTORY add: arg[1] {", arg[1], "}++++++++++++++++++++++++++\n");
print("             arg[2] {", arg[2], "}++++++++++++++++++++++++++\n");

		if (isBlank(arg[1]) == 1) {
			docTitle[count] = "no title";
		} else {
			/* make sure we're storing string representation,
			 * rather than possibly object pointer which can
			 * get us into trouble if that object is destroyed
			 * and we reference it.
			 */
			docTitle[index] = str(arg[1]);
		}
		docAddr[index] = arg[2];

		count++;

		victimIdx = count - killLatency;
		if (victimIdx >= 0) {
			victim = docAddr[victimIdx];
			if (victim != arg[2]) {
				print("KILLING idx=", victimIdx,
					"{", victim, "}\n");
				send(victim, "visible", 0);
				send(victim, "freeSelf");
			}
		}

/*		append(docTitle[index]);*/

		tt = "";
		for (i = 0; i < count; i++)
			tt = concat(tt, docTitle[i], '\n');
		set("content", tt);
print("HISTORY:{", tt, "}\n");
		highLight(index);
		if (get("window")) render();
		return;
	break;
	case "back":
		/* delete last line */
print("BACK count=", count, "\n");
		if (count >= 1) {
print("NOW DESTROY index=", index, ": {", docAddr[index], "}<<<<<<<<<<<,\n");

			www("destroyDoc", docAddr[index]);

			deHighLight(index);
			count--;
			if (index > -1) index--;
			previousDocIndx = index;
/*set("content", nthLine(get("content"), 0, count - 1));*/
/*GROSS*/		tt = "";
			for (i = 0; i < count; i++)
				tt = concat(tt, docTitle[i], '\n');
			set("content", tt);
			highLight(index);
			if (get("window")) render();
		}

print("NOW WANT index=",index, ": {", docAddr[index], "}\n");
print("HISTORY NOW:{", tt, "}\n");

		return docAddr[index];
	break;
	case "historyQuery":
		/* arg[1]	cookie
		 */
		wwwHistory_report(arg[1], docTitle);
		return;
	break;
	case "query": /* query(n) -> text on line n */
		return nthLine(get("content"), arg[1]);
	break;
	case "save":
		/* won't work */
		saveFile("~/.WWWHistory", get("content"));
		return;
	break;
	case "load":
		/* won't work */
		set("content", loadFile("~/.WWWHistory"));
		if (get("window")) render();
		return;
	break;
	case "clear":
		set("content", "");
	break;
	case "dump":
		for (i = 0; i < count; i++)
			print("[", i, "]\t docTitle={", docTitle[i], "}",
				"\tdocAddr={", docAddr[i], "}\n");
		return;
	break;
	case "keyPress":
		return; 
	break;
	case "enter":
		set("cursor", 0); 
		return;
	break;
	case "init":
		usual();
		previousDocIndx = -1;
		index = -1;
		count = 0;
		killLatency = 4;
		return;
	break;
	}
	usual();
}
\shownDepend {wwwHistory.list.sb}
\font {fixed}
\width {400}
\BGColor {LemonChiffon2}
\FGColor {black}
\BDColor {grey75}
\
